/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.wizardbatlle.modelo;


import java.util.ArrayList;

/**
 *
 * @author Bem vindo
 */
public class Personagem extends Desenho
{
    String nome;  
    String reino;

    int forca_total;
    int nivel_total;

    int vida;
    int poder;

    private boolean aguardando;
    
    ArrayList<Cartas> cartas;

    

    public int calcularForca()
    {
        int forca = 0;
    
        for (int i = 0;i < this.getCartas().size(); i++)
        {
           forca += this.getCartas().get(i).getForca();
        }
        forca = forca / this.getCartas().size();
    
        return forca;
    }

    public int calcularNivel()
{
        int nivel = 0;
    
        for (int i = 0;i < this.getCartas().size(); i++)
        {
           nivel += this.getCartas().get(i).getNivel();
        }
        nivel = nivel / this.getCartas().size();
    
        return nivel;
    }

    
    public void liberarCarta ()
    {
       boolean disponivel = false;
    
       int menor_nivel = MAXIMO_NIVEL;
       int index       = 0;
 
        for (int i = 0 ; i < this.getCartas().size(); i++)
            
        
       {
    
       if ( this.getCartas().get(i).getNivel() > menor_nivel )
       {
       
           menor_nivel = this.getCartas().get(i).getNivel() ;
           index       = i;
       }
    
       if ( this.getCartas().get(i).isDisponivel())
       {
           disponivel = true;
            break;   
       }
    
  } 
    
      if ( !disponivel ) 
      {
          this.getCartas().get(index).setDisponivel(true);
      }
    
    }          

    public void liberarTodasCarta ()
    {
       for (int i = 0 ; i < this.getCartas().size(); i++)
       {
          this.cartas.get(i).setEspera(0);
          this.cartas.get(i).setDisponivel(true);
       }
       
           
   }

   public void diminuirEspera ()
   {
      for (int i = 0 ; i < this.getCartas().size(); i++)
      {
      
        if (this.getCartas().get(i).getEspera()> 0 && this.getCartas().get(i).getEspera()!= 7)
      {
        
          this.getCartas().get(i).setEspera (this.getCartas().get(i).getEspera() - 1);
      }
   
    }
}
   public boolean emJogo ()
   {
      for (int i = 0 ; i < this.getCartas().size(); i++)
      {
         if (this.cartas.get(i).isEmjogo())
         {
           return true;
         }
      }
     return false;
   } 
   
   public boolean resetar ()
   {
      for (int i = 0 ; i < this.getCartas().size(); i++)
      {
         if (this.cartas.get(i).isEmjogo())
         {
            this.cartas.get(i).setEmjogo(false);
         
         }
      
      }
   
       return false;
   }
  
   public Cartas cartaEmJogo () 
   {
       for (int i = 0 ; i < this.getCartas().size(); i++)
       {
          if (this.cartas.get(i).isEmjogo())
          {
             return this.cartas.get(i);
          }
       }
   
       return null;
   }
   
   
   
   public String getNome()
    {
      return nome;
    }

    public String getReino()
    {
      return reino;
    }

    public int getForcaTotal()
    {
      return forca_total;
    }

    public int getNivelTotal()
    {
      return nivel_total;
    }

    public int getVida()
    {
      return vida;
    }

    public void setVida(int forca)
    {
      this.vida -= forca;
    }
    public void zeraVida()
    {
      this.vida = 0;
    }
    
    public int getPoder()
    {
      return poder;
    }

    public void setPoder(int forca)
    {
      this.poder -= forca;
    }
  
    public void setAumentodoPoder(int poder)
    {
      this.poder = poder;
    }
    
    public ArrayList<Cartas> getCartas()
    {
      return cartas;
    }

    public boolean isAguardando()
    {
      return aguardando;
    }

    public void setAguardando(boolean aguardando)
    {
      this.aguardando = aguardando;
    }
            
            
}
